//
//  ClassifierSVM.h
//  MANITEST
//
//  Created by Alhussein Fawzi on 03.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#ifndef __MANITEST__ClassifierLibSVM__
#define __MANITEST__ClassifierLibSVM__

#include <stdio.h>
#include <iostream>
#include <opencv2/ml/ml.hpp>

#include "SingleClassifier.h"
#include "svm.h"

#endif /* defined(__MANITEST__ClassifierSVM__) */

class ClassifierLibSVM: public SingleClassifier {
public:
    // Constructors
    ClassifierLibSVM() {}; // Create empty SVM classifier
    ClassifierLibSVM(svm_model *_model); // Create SVM classifier from the model in the argument
    
    // Classification function
    int classify(cv::Mat im);
    
    int load(const char *filename);
    
    // Pointer to model
    struct svm_model *model;
};