//
//  Classifiers.cpp
//  MANITEST
//
//  Created by Alhussein Fawzi on 03.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#include "Classifiers.h"

Classifiers::Classifiers () {
    ListClassifiers = std::vector<SingleClassifier*>(0);
}

Classifiers::Classifiers (std::vector<SingleClassifier*> *v) {
    ListClassifiers = *v;
}

void Classifiers::addClassifier(SingleClassifier *c) {
    ListClassifiers.push_back(c);
}

std::vector<int> Classifiers::classify(cv::Mat img, std::vector<bool> mask) {
    std::vector<int> estimated_labels;
    for (int i=0; i<ListClassifiers.size(); i++) {
        // estimated_labels.push_back(ListClassifiers[i].classify(img));
        // cout << "estimated_labels[" << i << "]" << " = " << estimated_labels[i] << endl;
        if (mask[i]) {
            estimated_labels.push_back(ListClassifiers[i]->classify(img));
        }
        else {
            estimated_labels.push_back(-1); // Otherwise, put garbage
        }
    }
    // cout << "estimated_label = " << estimated_labels[0] << endl;
    return estimated_labels;
}

std::vector<int> Classifiers::classify(cv::Mat img) {
    // Evaluate all classifiers
    std::vector<bool> mask((int) ListClassifiers.size(), true);
    return classify(img, mask);
}

void Classifiers::printClassifiers() {
    for (int i=0; i<ListClassifiers.size(); i++) {
        std::cout << "----------------------------" << std::endl;
        std::cout << "Classifier #" << i << std::endl;
        ListClassifiers[i]->printInfo();
    }
}