//
//  ScalRot.cpp
//  MANITEST
//
//  Created by Alhussein Fawzi on 17.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#include "ScalRot.h"

cv::Mat ScalRot::para2tfm(std::vector<double> para) {
    // assert(n_rows != -1 && n_cols != -1);
    int n_rows = (*img).rows; int n_cols = (*img).cols;
    cv::Point center = cv::Point( n_cols/2, n_rows/2 );
    cv::Mat tfm = cv::getRotationMatrix2D(center, para[1] * 180 / M_PI, para[0]);
    return tfm;
}

std::string ScalRot::getName() {
    return("ScalRot");
}

std::vector<double> ScalRot::getDefaultDiscretization() {
    return std::vector<double> {0.1, M_PI/20};
}

std::vector<double> ScalRot::getDefaultOffset() {
    return std::vector<double> {1, 0};
}